"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  byRole: () => byRole,
  getAccessibilityTree: () => getAccessibilityTree,
  pruneContainerNodes: () => pruneContainerNodes
});
module.exports = __toCommonJS(src_exports);

// src/tree/role-helpers.ts
var import_aria_query = require("aria-query");

// src/type-guards.ts
var isOptionElement = (element) => element.tagName === "OPTION";
var isInputElement = (element) => element.tagName === "INPUT";
var isDetailsElement = (element) => element.tagName === "DETAILS";
var isDefined = (value) => value !== void 0 && value !== null;
var isA11yTreeNode = (value) => typeof value === "object" && value !== null && "name" in value && "role" in value;
var isA11yTreeNodeMatch = (value) => typeof value === "object" && value !== null && ("name" in value || "role" in value || "description" in value || "state" in value || "children" in value);
var isTextMatcher = (value) => typeof value === "string" || typeof value === "number" || value instanceof RegExp || typeof value === "function";

// src/tree/virtual-roles.ts
var nonLandmarkVirtualRoles = [
  // https://w3c.github.io/html-aria/#el-header
  // header: 'HeaderAsNonLandmark',
  {
    match: (node) => {
      return node.tagName.toLowerCase() === "header";
    },
    roles: ["HeaderAsNonLandmark"],
    specificity: 1
  },
  // https://w3c.github.io/html-aria/#el-footer
  // footer: 'FooterAsNonLandmark',
  {
    match: (node) => node.tagName.toLowerCase() === "footer",
    roles: ["FooterAsNonLandmark"],
    specificity: 1
  }
];
var nonListListItemRoles = [
  // li: 'generic',
  // https://www.w3.org/TR/wai-aria-1.2/#listitem
  {
    match: (node) => node.tagName.toLowerCase() === "li",
    roles: ["generic"],
    specificity: 1
  }
];
var virtualRoles = [
  // abbr: 'Abbr'
  {
    match: (node) => node.tagName.toLowerCase() === "abbr",
    roles: ["Abbr"],
    specificity: 1
  },
  // audio: 'Audio',
  {
    match: (node) => node.tagName.toLowerCase() === "audio",
    roles: ["Audio"],
    specificity: 1
  },
  // canvas: 'Canvas',
  {
    match: (node) => node.tagName.toLowerCase() === "canvas",
    roles: ["Canvas"],
    specificity: 1
  },
  // details: 'Details',
  {
    match: (node) => node.tagName.toLowerCase() === "details",
    roles: ["Details"],
    specificity: 1
  },
  // dd: 'DescriptionListDetails',
  {
    match: (node) => node.tagName.toLowerCase() === "dd",
    roles: ["DescriptionListDetails"],
    specificity: 1
  },
  // dl: 'DescriptionList',
  {
    match: (node) => node.tagName.toLowerCase() === "dl",
    roles: ["DescriptionList"],
    specificity: 1
  },
  // dt: 'DescriptionListTerm',
  {
    match: (node) => node.tagName.toLowerCase() === "dt",
    roles: ["DescriptionListTerm"],
    specificity: 1
  },
  // embed: 'EmbeddedObject',
  {
    match: (node) => node.tagName.toLowerCase() === "embed",
    roles: ["EmbeddedObject"],
    specificity: 1
  },
  // figcaption: 'Figcaption',
  {
    match: (node) => node.tagName.toLowerCase() === "figcaption",
    roles: ["Figcaption"],
    specificity: 1
  },
  // object: 'PluginObject',
  {
    match: (node) => node.tagName.toLowerCase() === "object",
    roles: ["PluginObject"],
    specificity: 1
  },
  // label: 'LabelText',
  {
    match: (node) => node.tagName.toLowerCase() === "label",
    roles: ["LabelText"],
    specificity: 1
  },
  // br: 'LineBreak',
  {
    match: (node) => node.tagName.toLowerCase() === "br",
    roles: ["LineBreak"],
    specificity: 1
  },
  // summary: 'DisclosureTriangle',
  {
    match: (node) => node.tagName.toLowerCase() === "summary",
    roles: ["DisclosureTriangle"],
    specificity: 1
  },
  // video: 'Video',
  {
    match: (node) => node.tagName.toLowerCase() === "video",
    roles: ["Video"],
    specificity: 1
  }
];

// src/tree/role-helpers.ts
var elementRoleList = buildElementRoleList(import_aria_query.elementRoles);
function getImplicitAriaRoles(currentNode, { isListSubtree, isNonLandmarkSubtree }) {
  let result = [];
  for (const { match, roles } of elementRoleList) {
    if (match(currentNode)) {
      result = [...roles];
      break;
    }
  }
  if (!isListSubtree) {
    for (const { match, roles } of nonListListItemRoles) {
      if (match(currentNode)) {
        result = [...roles];
        break;
      }
    }
  }
  if (isNonLandmarkSubtree) {
    for (const { match, roles } of nonLandmarkVirtualRoles) {
      if (match(currentNode)) {
        result = [...roles];
        break;
      }
    }
  }
  if (result.length === 0) {
    for (const { match, roles } of virtualRoles) {
      if (match(currentNode)) {
        result = [...roles];
        break;
      }
    }
  }
  return result;
}
function buildElementRoleList(elementRolesMap) {
  function makeElementSelector({ name, attributes }) {
    return `${name}${(attributes != null ? attributes : []).map(({ name: attributeName, value, constraints = [] }) => {
      const shouldNotExist = constraints.indexOf("undefined") !== -1;
      if (shouldNotExist) {
        return `:not([${attributeName}])`;
      } else if (value) {
        return `[${attributeName}="${value}"]`;
      } else {
        return `[${attributeName}]`;
      }
    }).join("")}`;
  }
  function getSelectorSpecificity({
    attributes = []
  }) {
    return attributes.length;
  }
  function bySelectorSpecificity({ specificity: leftSpecificity }, { specificity: rightSpecificity }) {
    return rightSpecificity - leftSpecificity;
  }
  function match(element) {
    let { attributes = [] } = element;
    const typeTextIndex = attributes.findIndex(
      (attribute) => attribute.value && attribute.name === "type" && attribute.value === "text"
    );
    if (typeTextIndex >= 0) {
      attributes = [
        ...attributes.slice(0, typeTextIndex),
        ...attributes.slice(typeTextIndex + 1)
      ];
    }
    const selector = makeElementSelector(__spreadProps(__spreadValues({}, element), { attributes }));
    return (node) => {
      if (typeTextIndex >= 0 && isInputElement(node) && node.type !== "text") {
        return false;
      }
      return node.matches(selector);
    };
  }
  let result = [];
  for (const [element, roles] of elementRolesMap.entries()) {
    result = [
      ...result,
      {
        match: match(element),
        roles: Array.from(roles),
        specificity: getSelectorSpecificity(element)
      }
    ];
  }
  return result.sort(bySelectorSpecificity);
}

// src/tree/compute-properties.ts
function checkBooleanAttribute(element, attribute) {
  const attributeValue = element.getAttribute(attribute);
  if (attributeValue === "true") {
    return true;
  }
  if (attributeValue === "false") {
    return false;
  }
  return void 0;
}
function computeAriaSelected(element) {
  if (isOptionElement(element)) {
    return element.selected;
  }
  return checkBooleanAttribute(element, "aria-selected");
}
function computeAriaBusy(element) {
  return element.getAttribute("aria-busy") === "true";
}
function computeAriaChecked(element) {
  if ("indeterminate" in element && element.indeterminate) {
    return void 0;
  }
  if ("checked" in element) {
    return element.checked;
  }
  return checkBooleanAttribute(element, "aria-checked");
}
function computeAriaPressed(element) {
  return checkBooleanAttribute(element, "aria-pressed");
}
function computeAriaCurrent(element) {
  var _a, _b;
  return (_b = (_a = checkBooleanAttribute(element, "aria-current")) != null ? _a : element.getAttribute("aria-current")) != null ? _b : false;
}
function computeAriaExpanded(element) {
  if (isDetailsElement(element)) {
    return element.open;
  }
  return checkBooleanAttribute(element, "aria-expanded");
}
function computeHeadingLevel(element) {
  const implicitHeadingLevels = {
    H1: 1,
    H2: 2,
    H3: 3,
    H4: 4,
    H5: 5,
    H6: 6
  };
  const ariaLevelAttribute = element.getAttribute("aria-level") && Number(element.getAttribute("aria-level"));
  return ariaLevelAttribute || implicitHeadingLevels[element.tagName];
}
function computeAriaValueNow(element) {
  const valueNow = element.getAttribute("aria-valuenow");
  return valueNow === null ? void 0 : +valueNow;
}
function computeAriaValueMax(element) {
  const valueMax = element.getAttribute("aria-valuemax");
  return valueMax === null ? void 0 : +valueMax;
}
function computeAriaValueMin(element) {
  const valueMin = element.getAttribute("aria-valuemin");
  return valueMin === null ? void 0 : +valueMin;
}
function computeAriaValueText(element) {
  const valueText = element.getAttribute("aria-valuetext");
  return valueText === null ? void 0 : valueText;
}
function computeRoles(element, context) {
  let roles = [];
  if (element.hasAttribute("role")) {
    roles = element.getAttribute("role").split(" ").slice(0, 1);
  } else {
    roles = getImplicitAriaRoles(element, context);
  }
  return roles;
}

// src/tree/accessibility-tree.ts
var import_dom_accessibility_api = require("dom-accessibility-api");

// src/tree/leafs.ts
var StaticText = class {
  constructor(text) {
    this.text = text;
  }
  toString() {
    if (this.text === null) {
      return "null";
    }
    return this.text;
  }
};

// src/tree/accessibility-tree.ts
var isNonLandmarkRole = (element, role) => ["article", "aside", "main", "nav", "section"].includes(
  element.tagName.toLowerCase()
) || ["aricle", "complementary", "main", "navigation", "region"].includes(role);
var isList = (role) => role === "list";
var defaultOptions = {
  isListSubtree: false,
  isNonLandmarkSubtree: false
};
var getAccessibilityTree = (element, {
  isListSubtree: userListSubtree = defaultOptions.isListSubtree,
  isNonLandmarkSubtree: userNonLandmarkSubtree = defaultOptions.isNonLandmarkSubtree
} = defaultOptions) => {
  function assembleTree(element2, context) {
    if ((0, import_dom_accessibility_api.isInaccessible)(element2)) {
      return null;
    }
    const [role] = computeRoles(element2, context);
    const childNodes = Array.from(element2.childNodes);
    return {
      element: element2,
      role,
      name: (0, import_dom_accessibility_api.computeAccessibleName)(element2),
      description: (0, import_dom_accessibility_api.computeAccessibleDescription)(element2),
      state: {
        busy: computeAriaBusy(element2),
        checked: computeAriaChecked(element2),
        current: computeAriaCurrent(element2),
        disabled: (0, import_dom_accessibility_api.isDisabled)(element2),
        expanded: computeAriaExpanded(element2),
        pressed: computeAriaPressed(element2),
        selected: computeAriaSelected(element2)
      },
      queries: {
        level: computeHeadingLevel(element2),
        value: {
          min: computeAriaValueMin(element2),
          max: computeAriaValueMax(element2),
          now: computeAriaValueNow(element2),
          text: computeAriaValueText(element2)
        }
      },
      children: (childNodes != null ? childNodes : []).map((child) => {
        if (child instanceof HTMLElement) {
          return assembleTree(child, {
            isListSubtree: context.isListSubtree || isList(role),
            isNonLandmarkSubtree: context.isNonLandmarkSubtree || isNonLandmarkRole(element2, role)
          });
        }
        if (child instanceof Text) {
          if (child.textContent === null) {
            return void 0;
          }
          return new StaticText(child.textContent);
        }
        return void 0;
      }).filter(isDefined)
    };
  }
  return assembleTree(element, {
    isListSubtree: userListSubtree,
    isNonLandmarkSubtree: userNonLandmarkSubtree
  });
};

// src/helpers.ts
var import_lodash = __toESM(require("lodash.clonedeep"));
var import_lodash2 = __toESM(require("lodash.isequal"));
var containerAttributeValues = {
  name: "",
  role: "generic",
  description: ""
};
var defaultState = {
  busy: false,
  checked: void 0,
  current: false,
  disabled: false,
  expanded: void 0,
  pressed: void 0,
  selected: void 0
};
var getDefaultState = () => (0, import_lodash.default)(defaultState);
var defaultQueries = {
  level: void 0,
  value: {
    min: void 0,
    max: void 0,
    now: void 0,
    text: void 0
  }
};
var getDefaultQueries = () => (0, import_lodash.default)(defaultQueries);
var isDefaultState = (state) => {
  return (0, import_lodash2.default)(state, defaultState);
};
var isDefaultQueries = (queries) => {
  return (0, import_lodash2.default)(queries, defaultQueries);
};
var isDefaultAttributeValues = (node) => {
  return (node.role === containerAttributeValues.role || node.role === void 0) && node.name === containerAttributeValues.name && node.description === containerAttributeValues.description;
};
var isContainer = (node) => {
  return isDefaultAttributeValues(node) && isDefaultState(node.state) && isDefaultQueries(node.queries);
};

// src/tree/prune-container-nodes.ts
var pruneContainerNodes = (node) => {
  const flatten = (children) => {
    return children.flatMap(
      (child) => {
        if (child instanceof StaticText) {
          return [child];
        } else if (isContainer(child) && child.children) {
          return flatten(child.children);
        } else if (child.children) {
          return [__spreadProps(__spreadValues({}, child), { children: flatten(child.children) })];
        } else {
          return [child];
        }
      }
    );
  };
  return __spreadProps(__spreadValues({}, node), { children: node.children ? flatten(node.children) : [] });
};

// src/prepare-diff.ts
var import_lodash3 = __toESM(require("lodash.clonedeep"));
var getReceivedName = (node) => {
  if (node instanceof StaticText || !node) {
    return void 0;
  }
  return node.name;
};
var getReceivedRole = (node) => {
  var _a;
  if (node instanceof StaticText || !node) {
    return "";
  }
  return (_a = node.role) != null ? _a : void 0;
};
var getReceivedDescription = (node) => {
  if (node instanceof StaticText || !node) {
    return void 0;
  }
  return node.description;
};
var getReceivedChildren = (node) => {
  if (node instanceof StaticText || !node) {
    return void 0;
  }
  return node.children;
};
var computeTextValue = (received, expected, element) => {
  if (received === void 0) {
    return expected;
  }
  if (expected === void 0) {
    return received;
  }
  if (expected instanceof RegExp) {
    return expected.test(received) ? received : expected;
  }
  if (typeof expected === "function") {
    return expected(received, element) ? received : expected;
  }
  if (typeof expected === "string" || typeof expected === "number") {
    return received === expected.toString() ? received : expected;
  }
  return void 0;
};
var computeDiffState = (received, expected) => {
  var _a, _b, _c, _d, _e, _f, _g;
  let state = received instanceof StaticText || !received ? void 0 : __spreadValues({}, received.state);
  if (expected == null ? void 0 : expected.state) {
    if (state === void 0) {
      state = getDefaultState();
    }
    state.busy = (_a = expected.state.busy) != null ? _a : state.busy;
    state.checked = (_b = expected.state.checked) != null ? _b : state.checked;
    state.current = (_c = expected.state.current) != null ? _c : state.current;
    state.disabled = (_d = expected.state.disabled) != null ? _d : state.disabled;
    state.expanded = (_e = expected.state.expanded) != null ? _e : state.expanded;
    state.pressed = (_f = expected.state.pressed) != null ? _f : state.pressed;
    state.selected = (_g = expected.state.selected) != null ? _g : state.selected;
  }
  return state;
};
var computeDiffQueries = (received, expected, element) => {
  let queries = received instanceof StaticText || !received ? void 0 : (0, import_lodash3.default)(received.queries);
  if (expected == null ? void 0 : expected.queries) {
    if (queries === void 0) {
      queries = getDefaultQueries();
    }
    queries.level = expected.queries.level;
    if (expected.queries.value !== void 0) {
      if (expected.queries.value.min !== void 0) {
        queries.value.min = expected.queries.value.min;
      }
      if (expected.queries.value.max !== void 0) {
        queries.value.max = expected.queries.value.max;
      }
      if (expected.queries.value.now !== void 0) {
        queries.value.now = expected.queries.value.now;
      }
      if (expected.queries.value.text !== void 0) {
        queries.value.text = computeTextValue(
          isA11yTreeNode(received) ? received == null ? void 0 : received.queries.value.text : void 0,
          expected.queries.value.text,
          element
        );
      }
    }
  }
  return queries;
};
var matchToNode = (received, expected) => {
  var _a, _b, _c, _d;
  if (!received && !expected) {
    return void 0;
  }
  const element = isA11yTreeNode(received) ? received.element : null;
  const role = (_a = expected == null ? void 0 : expected.role) != null ? _a : getReceivedRole(received);
  const name = computeTextValue(
    getReceivedName(received),
    expected == null ? void 0 : expected.name,
    element
  );
  const description = computeTextValue(
    getReceivedDescription(received),
    expected == null ? void 0 : expected.description,
    element
  );
  const state = computeDiffState(received, expected);
  const queries = computeDiffQueries(received, expected, element);
  const receivedChildren = getReceivedChildren(received);
  const expectedChildren = expected == null ? void 0 : expected.children;
  const maxOfChildrenLengths = Math.max(
    (_c = (_b = expected == null ? void 0 : expected.children) == null ? void 0 : _b.length) != null ? _c : 0,
    (_d = receivedChildren == null ? void 0 : receivedChildren.length) != null ? _d : 0
  );
  const children = Array.from({ length: maxOfChildrenLengths }).map((_, index) => {
    const receivedChild = receivedChildren == null ? void 0 : receivedChildren[index];
    const expectedChild = expectedChildren == null ? void 0 : expectedChildren[index];
    if (typeof expectedChild === "string") {
      return new StaticText(expectedChild);
    }
    if (expectedChild instanceof RegExp) {
      if (receivedChild instanceof StaticText && receivedChild.text && expectedChild.test(receivedChild.text)) {
        return receivedChild;
      }
      return expectedChild;
    }
    if (expectedChild === void 0) {
      if (name && maxOfChildrenLengths === 1) {
        if (name instanceof RegExp || typeof name === "function") {
          return name;
        }
        return new StaticText(
          typeof name === "string" ? name : name.toString()
        );
      }
      return void 0;
    }
    return matchToNode(receivedChild, expectedChild);
  }).filter(Boolean);
  const result = {
    role,
    name,
    description,
    state,
    queries,
    children
  };
  return result;
};

// src/pretty-tree/omit-default-values.ts
function isNestedObject(value) {
  return typeof value === "object" && value !== null && !(value instanceof RegExp);
}
function omitDefaultValues(target, defaults) {
  const filteredObject = {};
  Object.keys(target).forEach((key) => {
    const targetValue = target[key];
    const defaultValue = defaults[key];
    if (targetValue !== defaultValue && targetValue !== void 0) {
      filteredObject[key] = targetValue;
    } else if (isNestedObject(targetValue) && isNestedObject(defaultValue)) {
      const result = omitDefaultValues(targetValue, defaultValue);
      if (Object.keys(result).length > 0) {
        filteredObject[key] = result;
      }
    }
  });
  return filteredObject;
}

// src/pretty-tree/render-properties.ts
var renderPropertyValue = (value) => {
  switch (typeof value) {
    case "function":
      return "Function";
    case "number":
    case "boolean":
      return String(value);
    case "undefined":
      return "";
    case "object":
      if (value instanceof RegExp) {
        return value.toString();
      }
      return "";
    default:
      return `"${value}"`;
  }
};
var renderProperties = (obj, prefix = "") => {
  const keyValuePairs = Object.entries(obj).flatMap(([key, value]) => {
    if (value === void 0) {
      return [];
    }
    const fullKey = prefix ? `${prefix}.${key}` : key;
    if (typeof value === "object" && !(value instanceof RegExp) && !(value instanceof Function)) {
      return renderProperties(value, fullKey);
    } else {
      const renderedValue = renderPropertyValue(value);
      return renderedValue ? `${fullKey}=${renderedValue}` : [];
    }
  });
  return keyValuePairs.join(" ");
};

// src/pretty-tree/pretty-tree.ts
var renderStringMatcher = (textMatcher) => {
  if (textMatcher instanceof RegExp || typeof textMatcher === "number") {
    return textMatcher.toString();
  }
  if (typeof textMatcher === "function") {
    return textMatcher.toString();
  }
  return `"${textMatcher}"`;
};
var getPrettyTree = (tree, depth = 0) => {
  const indentation = "  ".repeat(depth);
  if (typeof tree === "string" || typeof tree === "number") {
    return `${indentation}"${tree}"
`;
  }
  if (tree instanceof RegExp) {
    return `${indentation}${tree.toString()}
`;
  }
  if (tree instanceof StaticText) {
    return `${indentation}StaticText "${tree.text}"
`;
  }
  if (tree === void 0) {
    return `${indentation}undefined
`;
  }
  if (typeof tree === "function") {
    return `${indentation}${tree.toString()}
`;
  }
  const filteredState = tree.state ? omitDefaultValues(tree.state, defaultState) : void 0;
  const filteredQueries = tree.queries ? omitDefaultValues(tree.queries, defaultQueries) : void 0;
  const nameString = tree.name ? ` ${renderStringMatcher(tree.name)}` : "";
  const stateString = filteredState ? ` ${renderProperties(filteredState)}` : "";
  const queriesString = filteredQueries ? ` ${renderProperties(filteredQueries)}` : "";
  let output = `${indentation}${tree.role}${nameString}${stateString}${queriesString}
`;
  if (tree.description) {
    output += `${indentation}  description: ${renderStringMatcher(
      tree.description
    )}
`;
  }
  if (tree.children) {
    tree.children.forEach((child) => {
      output += getPrettyTree(child, depth + 1);
    });
  }
  return output;
};

// src/testers/text.ts
var textTester = (received, expected, element) => {
  if (typeof expected === "undefined") {
    return true;
  }
  if (typeof expected === "string") {
    return received === expected;
  }
  if (typeof expected === "number") {
    return received === expected.toString();
  }
  if (expected instanceof RegExp) {
    return expected.test(received);
  }
  if (typeof expected === "function") {
    return expected(received, element);
  }
  return false;
};

// src/testers/queries.ts
var queriesTester = (received, expected) => {
  if (typeof expected === "undefined") {
    return true;
  }
  let result = true;
  if (expected.level !== void 0) {
    result && (result = received.level === expected.level);
  }
  if (expected.value !== void 0) {
    if (expected.value.min !== void 0) {
      result && (result = received.value.min === expected.value.min);
    }
    if (expected.value.max !== void 0) {
      result && (result = received.value.max === expected.value.max);
    }
    if (expected.value.now !== void 0) {
      result && (result = received.value.now === expected.value.now);
    }
    if (expected.value.text !== void 0) {
      if (received.value.text === void 0) {
        result && (result = received.value.text === expected.value.text);
      } else {
        result && (result = textTester(received.value.text, expected.value.text, null));
      }
    }
  }
  return result;
};

// src/testers/role.ts
var roleTester = (received, expected) => {
  if (typeof expected === "undefined") {
    return true;
  }
  if (typeof expected === "string") {
    return received === expected;
  }
  return false;
};

// src/testers/state.ts
var stateTester = (received, expected) => {
  if (typeof expected === "undefined") {
    return true;
  }
  const expectedKeys = Object.keys(
    expected
  );
  return expectedKeys.every((key) => {
    if (typeof expected[key] === "undefined") {
      return true;
    }
    if (typeof expected[key] === "boolean") {
      return received[key] === expected[key];
    }
    if (typeof expected[key] === "string") {
      return received[key] === expected[key];
    }
    return false;
  });
};

// src/testers/node.ts
function nodeTester(received, expected) {
  if (!roleTester(received.role, expected.role)) {
    return false;
  }
  if (!textTester(received.name, expected.name, received.element)) {
    return false;
  }
  if (!textTester(received.description, expected.description, received.element)) {
    return false;
  }
  if (!stateTester(received.state, expected.state)) {
    return false;
  }
  if (!queriesTester(received.queries, expected.queries)) {
    return false;
  }
  let isEqual = true;
  if (expected.children !== void 0) {
    if (received.children === void 0) {
      throw new Error("treeNodeMatcher: a.children is undefined");
    }
    if (received.children.length !== expected.children.length) {
      return false;
    }
    for (let i = 0; i < received.children.length; i++) {
      if (!isEqual) {
        break;
      }
      const child = received.children[i];
      const childMatcher = expected.children[i];
      if (isA11yTreeNode(child) && isA11yTreeNodeMatch(childMatcher)) {
        isEqual && (isEqual = nodeTester(child, childMatcher));
        continue;
      }
      if (child instanceof StaticText && isTextMatcher(childMatcher)) {
        isEqual && (isEqual = textTester(child.text, childMatcher, null));
        continue;
      }
      isEqual = false;
    }
  }
  return isEqual;
}

// src/matchers.ts
expect.extend({
  toHaveA11yTree(received, expected, options) {
    if (received instanceof HTMLElement) {
      const tree = getAccessibilityTree(received, options);
      if (tree === null) {
        return {
          message: () => "Failed to get accessible tree",
          pass: false
        };
      }
      const flatTree = pruneContainerNodes(tree);
      if (flatTree === null) {
        return {
          message: () => "Failed to flatten accessible tree",
          pass: false
        };
      }
      received = flatTree;
    }
    const pass = nodeTester(received, expected);
    const expectedPreparedForDiff = matchToNode(received, expected);
    const receivedPrettyTree = getPrettyTree(received);
    const expectedPrettyTree = getPrettyTree(expectedPreparedForDiff);
    if (pass) {
      return {
        message: () => `${this.utils.diff(expectedPrettyTree, receivedPrettyTree)}`,
        pass: true
      };
    }
    return {
      message: () => `${this.utils.diff(expectedPrettyTree, receivedPrettyTree)}`,
      pass: false
    };
  }
});

// src/helpers/by-role.ts
function anyObjectPropertiesAreDefined(obj) {
  return Object.values(obj).some((value) => value !== void 0);
}
function byRole(role, nameOrPropertiesOrChildren, childrenIfProvided) {
  const a11yNode = {
    role
  };
  if (typeof nameOrPropertiesOrChildren === "undefined") {
    return a11yNode;
  } else if (isTextMatcher(nameOrPropertiesOrChildren)) {
    a11yNode.name = nameOrPropertiesOrChildren;
    if (Array.isArray(childrenIfProvided)) {
      a11yNode.children = childrenIfProvided;
    }
  } else if (Array.isArray(nameOrPropertiesOrChildren)) {
    a11yNode.children = nameOrPropertiesOrChildren;
  } else if (typeof nameOrPropertiesOrChildren === "object") {
    const _a = nameOrPropertiesOrChildren, { name, description } = _a, stateAndQueries = __objRest(_a, ["name", "description"]);
    a11yNode.name = name;
    a11yNode.description = description;
    const _b = stateAndQueries, { level, value } = _b, state = __objRest(_b, ["level", "value"]);
    const queries = { level, value };
    a11yNode.state = anyObjectPropertiesAreDefined(state) ? state : void 0;
    a11yNode.queries = anyObjectPropertiesAreDefined(queries) ? queries : void 0;
    if (Array.isArray(childrenIfProvided)) {
      a11yNode.children = childrenIfProvided;
    }
  }
  return a11yNode;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  byRole,
  getAccessibilityTree,
  pruneContainerNodes
});
//# sourceMappingURL=index.js.map